unit fracoverimage;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, ExtCtrls, Buttons, fracoverobject,
  lclmediators, covermediators, StdCtrls, cdcovers,ExtDlgs;

type
  TFrame = TCoverObjectFrame;

  { TImageObjectFrame }

  TImageObjectFrame = class(TFrame)
    CBStretched: TCheckBox;
    CBCentered: TCheckBox;
    IObject: TImage;
    OPDImage: TOpenPictureDialog;
    PButtons: TPanel;
    SPDImage: TSavePictureDialog;
    SBSave: TSpeedButton;
    SBLoad: TSpeedButton;
    procedure SBLoadClick(Sender: TObject);
    procedure SBSaveClick(Sender: TObject);
  private
    { private declarations }
    FImageMediator : TImageMediator;
    FStretchedMediator : TCheckBoxMediator;
    FCenteredMediator : TCheckBoxMediator;
  Protected
    Function GetTabCaption : String; override;
  public
    { public declarations }
    Procedure InitFrame; override;
  end; 

implementation

{ TImageObjectFrame }

procedure TImageObjectFrame.SBLoadClick(Sender: TObject);
begin
  With OPDImage do
    If Execute then
      IObject.Picture.LoadFromFile(FileName);
end;


procedure TImageObjectFrame.SBSaveClick(Sender: TObject);
begin
  With SPDImage do
    If Execute then
      IObject.Picture.SaveToFile(FileName);
end;

function TImageObjectFrame.GetTabCaption: String;
begin
  Result:='Image';
end;

procedure TImageObjectFrame.InitFrame;
begin
  inherited InitFrame;
  FImageMediator:=TImageMediator.Create(Self);
  FImageMediator.Control:=IObject;
  FImageMediator.SubjectPropertyName:='Picture';
  FImageMediator.StretchPropertyName:='Stretched';
  FImageMediator.CenterPropertyName:='Centered';
  FStretchedMediator:=TCheckBoxMediator.Create(Self);
  FStretchedMediator.Control:=CBStretched;
  FStretchedMediator.SubjectPropertyName:='Stretched';
  FCenteredMediator:=TCheckBoxMediator.Create(Self);
  FCenteredMediator.Control:=CBCentered;
  FCenteredMediator.SubjectPropertyName:='Centered';
end;

initialization
  {$I fracoverimage.lrs}

end.

