unit fracoverlabel;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, fracoverobject, ExtCtrls,
  StdCtrls, cdcovers, lclmediators, covermediators, buttons, graphics, Dialogs;

type

  TFrame = TCoverObjectFrame;

  { TCoverLabelFrame }

  TCoverLabelFrame = class(TFrame)
    CBFillColor: TColorButton;
    CBWordWrap: TCheckBox;
    CBTransparent: TCheckBox;
    FillColor: TLabel;
    FDLabel: TFontDialog;
    MLabel: TMemo;
    Panel1: TPanel;
    SBAlignBottom: TSpeedButton;
    SBAlignCenter: TSpeedButton;
    SBAlignLeft: TSpeedButton;
    SBAlignRight: TSpeedButton;
    SBAlignTop: TSpeedButton;
    SBCentered: TSpeedButton;
    SBfont: TSpeedButton;
    procedure DoObjectToView(Sender: TObject; var Handled: Boolean);
    procedure SBfontClick(Sender: TObject);
  private
    { private declarations }
    FLabelMediator : TMemoMediator;
    FAlignLeftMediator,
    FCenteredMediator,
    FAlignRightMediator : TAlignmentMediator;
    FATopMediator,
    FACenterMediator,
    FABottomMediator : TLayoutMediator;
    FTransparentMediator,
    FWordWrapMediator : TCheckboxMediator;
    FFillColorMediator : TColorButtonmediator;
  Protected
    function GetTabCaption: String; override;
  public
    { public declarations }
    procedure initframe; override;
  end; 

implementation

{ TCoverLabelFrame }

procedure TCoverLabelFrame.DoObjectToView(Sender: TObject; var Handled: Boolean
  );

Var
  L : TLabelObject;

begin
  L:=(Sender as TMemoMediator).Subject as TLabelObject;
  Mlabel.Alignment:=L.Alignment;
  if L.TransParent then
    MLabel.Color:=clWindow
  else
    MLabel.Color:=L.FillColor;
  MLabel.Font:=L.Font;
  Handled:=False;
end;

procedure TCoverLabelFrame.SBfontClick(Sender: TObject);

Var
  L : TLabelObject;

begin
  L:=FLabelMediator.Subject as TLabelObject;
  With FDLabel do
    begin
    Font:=L.Font;
    If Execute then
      L.Font:=Font;
    end;
end;

function TCoverLabelFrame.GetTabCaption: String;
begin
  Result:='Text';
end;

procedure TCoverLabelFrame.initframe;

   Function SA(ASpeedButton : TSpeedButton; AAlignment : TAlignment) : TAlignmentMediator;

   begin
     Result:=TAlignmentMediator.Create(Self);
     Result.Control:=ASpeedButton;
     Result.SubjectPropertyName:='Alignment';
     Result.Alignment:=AAlignment;
   end;

   Function SL(ASpeedButton : TSpeedButton; ALayout : TTextLayout) : TLayoutMediator;

   begin
     Result:=TLayoutMediator.Create(Self);
     Result.Control:=ASpeedButton;
     Result.SubjectPropertyName:='Layout';
     Result.Layout:=ALayout;
   end;
begin
  inherited initframe;
  FLabelMediator:=TMemoMediator.Create(Self);
  FLabelMediator.SubjectPropertyName:='Caption';
  FLabelMediator.COntrol:=MLabel;
  FLabelMediator.OnObjectToView:=@DoObjectToView;
  FAlignLeftMediator:=SA(SBAlignLeft,taLeftJustify);
  FAlignRightMediator:=SA(SBAlignRight,taRightJustify);
  FCenteredMediator:=SA(SBCentered,taCenter);
  FATopMediator:=SL(SBAlignTop,tlTop);
  FACenterMediator:=SL(SBAlignCenter,tlCenter);
  FABottomMediator:=SL(SBAlignBottom,tlBottom);
  FTransparentMediator:=TCheckboxMediator.Create(Self);
  FTransparentMediator.Control:=CBTransparent;
  FTransparentMediator.SubjectPropertyName:='Transparent';
  FWordWrapMediator:=TCheckboxMediator.Create(Self);
  FWordWrapMediator.Control:=CBWordWrap;
  FWordWrapMediator.SubjectPropertyName:='WordWrap';
  FFillColorMediator:=TColorButtonmediator.Create(Self);
  FFillColorMediator.Control:=CBFillColor;
  FFillColorMediator.SubjectPropertyName:='FillColor';
end;

initialization
  {$I fracoverlabel.lrs}

end.

