unit fracoverobject;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, forms, cdcovers, fpobserver;

Type

  { TCoverObjectFrame }

  TCoverObjectFrame = Class(TFrame)
  private
    FCoverObject: TCoverObject;
  Protected
    function GetTabCaption: String; virtual;
    procedure SetCoverObject(const AValue: TCoverObject); virtual;
  Public
    Procedure InitFrame; virtual;
    Property CoverObject : TCoverObject Read FCoverObject Write SetCoverObject;
    Property TabCaption : String Read GetTabCaption;
  end;
  TObjectCoverFrameClass = Class of TCoverObjectFrame;

implementation

{ TCoverObjectFrame }

procedure TCoverObjectFrame.SetCoverObject(const AValue: TCoverObject);

Var
  I : Integer;
  M : TBaseMediator;

begin
  if FCoverObject=AValue then exit;
  FCoverObject:=AValue;
  For I:=0 to ComponentCount-1 do
    If Components[i] is TBaseMediator then
      begin
      M:=Components[i] as TBaseMediator;
      M.Subject:=AValue;
      M.Active:=True;
      end;
end;

function TCoverObjectFrame.GetTabCaption: String;
begin
  Result:='';
end;

procedure TCoverObjectFrame.InitFrame;
begin
  // Do nothing
end;

end.

