unit fracovershape;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, ExtCtrls, StdCtrls, fracoverobject,
  Dialogs, lclmediators, covermediators, ComCtrls, Spin, cdcovers;

type

  TFrame = TCoverObjectFrame;

  { TCoverShapeFrame }

  TCoverShapeFrame = class(TFrame)
    CBPenColor: TColorButton;
    CBFillColor: TColorButton;
    CBTransparent: TCheckBox;
    SERRH: TFloatSpinEdit;
    SERRV: TFloatSpinEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    LTBLineWidth: TLabel;
    LLineColor: TLabel;
    LSample: TLabel;
    PSample: TPanel;
    RGShapeType: TRadioGroup;
    TBLineWidth: TTrackBar;
  private
    { private declarations }
    FPanelMediator : TPanelShapeMediator;
    FTypeMediator : TRadioGroupMediator;
    FPenColorMediator: TColorButtonMediator;
    FFillColorMediator: TColorButtonMediator;
    FTransparentMediator : TCheckBoxMediator;
    FLineWidthMediator: TTrackbarMediator;
    FRRHRadius: TFloatSpinEditMediator;
    FRRVRadius: TFloatSpinEditMediator;
  Protected
    function GetTabCaption: String; override;
    procedure EnableOrDisable(Sender: TObject; var Handled: Boolean);
  public
    { public declarations }
    procedure initframe; override;
  end;

implementation

{ TCoverShapeFrame }

procedure TCoverShapeFrame.EnableOrDisable(Sender: TObject; var Handled: Boolean);

Var
  SEM : TFloatSpinEditMediator;
begin
  SEM:=(Sender as TFloatSpinEditMediator);
  Handled:=TShapeObject(SEM.Subject).ShapeType<>stRoundedRectangle;
  (Sender as TFloatSpinEditMediator).Control.Enabled:=Not Handled;
end;

function TCoverShapeFrame.GetTabCaption: String;
begin
  Result:='Shape';
end;

procedure TCoverShapeFrame.initframe;
begin
  inherited initframe;
  FPanelMediator:=TPanelShapeMediator.Create(Self);
  FPanelMediator.Control:=PSample;
  FTypeMediator:=TRadioGroupMediator.Create(Self);
  FTypeMediator.Control:=RGShapeType;
  FTypeMediator.SubjectpropertyName:='ShapeType';
  FPenColorMediator:=TColorButtonMediator.Create(Self);
  FPenColorMediator.Control:=CBPenCOlor;
  FPenColorMediator.SubjectPropertyName:='PenColor';
  FFillColorMediator:=TColorButtonMediator.Create(Self);
  FFillColorMediator.Control:=CBFillCOlor;
  FFillColorMediator.SubjectPropertyName:='FillColor';
  FTransparentMediator:=TCheckBoxMediator.Create(Self);
  FTransparentMediator.Control:=CBTransparent;
  FTransparentMediator.SubjectPropertyName:='Transparent';
  FLineWidthMediator:=TTrackbarMediator.Create(Self);
  FLineWidthMediator.Control:=TBLineWidth;
  FLineWidthMediator.SubjectPropertyName:='PenWidth';
  FRRHRadius:=TFloatSpinEditMediator.Create(Self);
  FRRHRadius.Control:=SERRH;
  FRRHRadius.SubjectPropertyName:='RoundRHRadius';
  FRRHRadius.OnObjectToView:=@EnableOrDisable;
  FRRVRadius:=TFloatSpinEditMediator.Create(Self);
  FRRVRadius.Control:=SERRV;
  FRRVRadius.SubjectPropertyName:='RoundRVRadius';
  FRRVRadius.OnObjectToView:=@EnableOrDisable;
end;

initialization
  {$I fracovershape.lrs}

end.

