unit frmAdjustSize;

{$MODE objfpc}
{$h+}

interface

uses
  Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, ExtCtrls , LResources, Spin, ButtonPanel, cdcovers;

type

  { TAdjustSizeForm }

  TAdjustSizeForm = class(TForm)
    ButtonPanel1: TButtonPanel;
    EHeight: TFloatSpinEdit;
    EWidth: TFloatSpinEdit;
    HeightRG: TRadioGroup;
    WidthRG: TRadioGroup;
    procedure CheckEdit(Sender: TObject);
    procedure ResetForm(Sender: TObject);
  private
    function GetH: TSizeAdjust;
    function GetHS: Double;
    function GetV: TSizeAdjust;
    function GetVS: Double;
    procedure SetH(const AValue: TSizeAdjust);
    procedure SetHS(const AValue: Double);
    procedure SetV(const AValue: TSizeAdjust);
    procedure SetVS(const AValue: Double);
    { Private declarations }
  public
    { Public declarations }
    Property HOperation : TSizeAdjust Read GetH Write SetH;
    Property VOperation : TSizeAdjust Read GetV Write SetV;
    Property HSize : Double Read GetHS Write SetHS;
    Property VSize : Double Read GetVS Write SetVS;
  end;

var
  AdjustSizeForm: TAdjustSizeForm;

implementation


procedure TAdjustSizeForm.CheckEdit(Sender: TObject);

Var
  OnOff : Boolean;
  Edit  : TFloatSpinEdit;

begin
  With (Sender as TRadioGroup) do
    OnOff:=ItemIndex=Items.Count-1;
  If Sender=WidthRG then
    Edit:=EWidth
  else
    Edit:=EHeight;
  Edit.Enabled:=OnOff;
  If OnOff then
    Edit.Value:=1.0
  else
    Edit.Value:=0.0;
end;

procedure TAdjustSizeForm.ResetForm(Sender: TObject);
begin
  WidthRG.ItemIndex:=0;
  HeightRG.ItemIndex:=0;
end;

function TAdjustSizeForm.GetH: TSizeAdjust;
begin
  Result:=TSizeAdjust(WidthRG.ItemIndex);
end;

function TAdjustSizeForm.GetHS: Double;
begin
  Result:=EWidth.Value;
end;

function TAdjustSizeForm.GetV: TSizeAdjust;
begin
  Result:=TSizeAdjust(HeightRG.ItemIndex);
end;

function TAdjustSizeForm.GetVS: Double;
begin
  Result:=EHeight.Value;
end;

procedure TAdjustSizeForm.SetH(const AValue: TSizeAdjust);
begin
  WidthRG.ItemIndex:=Ord(AValue);
end;

procedure TAdjustSizeForm.SetHS(const AValue: Double);
begin
  EWidth.Value:=AValue;
end;

procedure TAdjustSizeForm.SetV(const AValue: TSizeAdjust);
begin
  HeightRG.ItemIndex:=Ord(AValue);
end;

procedure TAdjustSizeForm.SetVS(const AValue: Double);
begin
  EHeight.Value:=AValue;
end;

initialization
  {$i frmAdjustSize.lrs}

end.
