unit frmaddpage;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  ExtCtrls, StdCtrls, ButtonPanel, cdcovers;

type

  { TAddPagesForm }

  TAddPagesForm = class(TForm)
    ButtonPanel1: TButtonPanel;
    CGPageTypes: TCheckGroup;
    procedure FormCreate(Sender: TObject);
  private
    FCDCover: TCDCover;
    function GetPageTypes: TPageTypes;
    procedure SetCDCOver(const AValue: TCDCover);
    procedure SetPageTypes(const AValue: TPageTypes);
    { private declarations }
  public
    { public declarations }
    Property PageTypes : TPageTypes Read GetPageTypes Write SetPageTypes;
    Property CDCover : TCDCover Read FCDCover Write SetCDCOver;
  end; 

var
  AddPagesForm: TAddPagesForm;

implementation


{ TAddPagesForm }

procedure TAddPagesForm.FormCreate(Sender: TObject);

Var
  T : TPageType;

begin
  With CGPageTypes.Items do
    begin
    BeginUpdate;
    try
      For T:=Low(TPageType) to High(TPageType) do
        Add(PageTypeName(T));
    finally
      EndUpdate;
    end;
    end;
end;

function TAddPagesForm.GetPageTypes: TPageTypes;

Var
  I : Integer;
  T : TPageType;

begin
  Result:=[];
  T:=Low(TpageType);
  For I:=0 to CGPageTypes.Items.Count-1 do
    begin
    If CGPageTypes.Checked[I] then
      Include(Result,T);
    T:=Succ(T);
    end;
end;

procedure TAddPagesForm.SetCDCOver(const AValue: TCDCover);




Var
  T : TPageType;
  TS : TPageTypes;

begin
  if FCDCover=AValue then exit;
  FCDCover:=AValue;
  For T:=Low(TPageType) to High(TPageType) do
    CGPageTypes.CheckEnabled[Ord(T)]:=(T=ptDiscLabel) or Not CDCover.HavePageType(T);
end;

procedure TAddPagesForm.SetPageTypes(const AValue: TPageTypes);

Var
  I : Integer;
  T : TPageType;

begin
  T:=Low(TpageType);
  For I:=0 to CGPageTypes.Items.Count-1 do
    begin
    CGPageTypes.Checked[I]:=T in AValue;
    T:=Succ(T);
    end;
end;

initialization
  {$I frmaddpage.lrs}

end.

