unit frmconfig;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  ButtonPanel, StdCtrls, EditBtn, fpobserver, coverconfig, lclmediators;

type

  { TConfigurationForm }

  TConfigurationForm = class(TForm)
    ButtonPanel1: TButtonPanel;
    CBCDROM: TComboBox;
    CBCache: TCheckBox;
    DECache: TDirectoryEdit;
    EUser: TEdit;
    EURL: TEdit;
    LDECache: TLabel;
    LUser: TLabel;
    LURL: TLabel;
    LCBCDRom: TLabel;
    procedure CBCacheChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    FConfig: TCDCoverConfiguration;
    FDeviceMediator : TComboBoxMediator;
    FURLMediator : TEditmediator;
    FUserMediator : TEditmediator;
    FUseCacheMediator : TCheckboxMediator;
    FCacheDirMediator : TEditmediator;
    procedure SetConfig(const AValue: TCDCoverConfiguration);
    { private declarations }
  public
    { public declarations }
    Property Config : TCDCoverConfiguration Read FConfig Write SetConfig;
  end;

var
  ConfigurationForm: TConfigurationForm;

implementation

uses cdrom;

{ TConfigurationForm }

procedure TConfigurationForm.CBCacheChange(Sender: TObject);
begin
  DECache.Enabled:=CBCache.Checked;
end;

procedure TConfigurationForm.FormCreate(Sender: TObject);

Var
  Drives : Array[1..10] of String;
  I,Count : Integer;

begin
  Count:=GetCDRomDevices(Drives);
  For I:=1 to Count do
    CBCDRom.Items.add(Drives[i]);
  // Device
  FDeviceMediator:=TComboBoxMediator.Create(Self);
  FDeviceMediator.Control:=CBCDRom;
  FDeviceMediator.SubjectPropertyName:='CDDevice';
  // URL
  FURLMediator:=TEditmediator.Create(Self);
  FURLMediator.Control:=EURL;
  FURLMediator.SubjectPropertyName:='CDDBHostURL';
  // Username
  FUserMediator:=TEditmediator.Create(Self);
  FUserMediator.Control:=EUSer;
  FUserMediator.SubjectPropertyName:='CDDBUser';
  // UseCache
  FUseCacheMediator:=TCheckboxMediator.Create(Self);
  FUseCacheMediator.COntrol:=CBCache;
  FUseCacheMediator.SubjectPropertyName:='CDDBUseCache';
  // Cache Dir
  FCacheDirMediator:=TDirectoryEditMediator.Create(Self);
  FCacheDirMediator.Control:=DECache;
  FCacheDirMediator.SubjectPropertyName:='CDDBCacheDir';
end;

procedure TConfigurationForm.SetConfig(const AValue: TCDCoverConfiguration);

Var
  I : Integer;

begin
  if FConfig=AValue then exit;
  FConfig:=AValue;
  For I:=0 to ComponentCount-1 do
   If (Components[i] is TBaseMediator) then
     With TBaseMediator(Components[i]) do
       begin
       Subject:=FConfig;
       Active:=True;
       end;
end;

initialization
  {$I frmconfig.lrs}

end.

