unit frmcoverproperties;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, LResources, Forms, Controls, Graphics, Dialogs,
  StdCtrls, ButtonPanel, fpObserver, lclmediators, cdcovers;

type

  { TCoverPropertiesForm }

  TCoverPropertiesForm = class(TForm)
    ButtonPanel1: TButtonPanel;
    ETitle: TEdit;
    EPerformer: TEdit;
    LETitle: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    MDescription: TMemo;
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
  private
    FCover: TCDCover;
    { private declarations }
    FTitleMediator,
    FPerformerMediator : TEditMediator;
    FDescriptionMediator : TMemoMediator;
    FMemento : TMemento;
    procedure SetCover(const AValue: TCDCover);
  public
    { public declarations }
    Property CDCover : TCDCover Read FCover Write SetCover;
  end; 

var
  CoverPropertiesForm: TCoverPropertiesForm;

implementation

{ TCoverPropertiesForm }

procedure TCoverPropertiesForm.FormCreate(Sender: TObject);
begin
  FTitleMediator:=TeditMediator.Create(Self);
  FTitleMediator.Control:=ETitle;
  FTitleMediator.SubjectPropertyName:='Title';
  FPerformerMediator:=TEditMediator.Create(Self);
  FPerformerMediator.Control:=EPerformer;
  FPerformerMediator.SubjectPropertyName:='Performer';
  FDescriptionMediator:=TMemoMediator.Create(Self);
  FDescriptionMediator.Control:=MDescription;
  FDescriptionMediator.SubjectPropertyName:='Description';
end;

procedure TCoverPropertiesForm.FormClose(Sender: TObject;
  var CloseAction: TCloseAction);
begin
  if (ModalResult<>mrOK) and Assigned(FMemento) and Assigned(FCover) then
    FCover.Applymemento(FMemento);
end;

procedure TCoverPropertiesForm.SetCover(const AValue: TCDCover);

Var
  I : integer;

begin
  if FCover=AValue then exit;
  FCover:=AValue;
  For I:=0 to ComponentCount-1 do
    if components[i] is TBaseMediator then
      begin
      TBaseMediator(components[i]).Subject:=AValue;
      TBaseMediator(components[i]).Active:=True;
      end;
  FMemento:=AValue.GetMemento;
end;

initialization
  {$I frmcoverproperties.lrs}

end.

